/* Autor: Tomasz Kogut, Grupa dziekaska: 5ISI.
 * Ostatnia aktualizacja: 11.12.2008
 */

/* Opis */
/*---------------------------------------------*/
/* Poniszy listing ma za zadanie pokaza uycie funkcji bibliotecznych:
 * bool is_sorted( iterator start, iterator end );
 * bool is_sorted( iterator start, iterator end, Ordering cmp )
 * ktrych zadaniem jest stwierdzenie czy dany zbir jest posortowany.
 */


/* Biblioteka zawierajca nasz funkcje. Bez niej nie moemy uywa
 * funkcji is_sorted.
 */
#include <ext/algorithm>
#include <iostream>
#include <vector>
#include <iterator>
#include <cmath>

using namespace std;



/* Klasa reprezentujca zwyky kwadrat.
 * Ma jedn skadow - dugo boku, ktra jest cakowita.
 * Klasa stworzona do zaprezentowania przykadowego uycia.
 */
class Kwadrat {
	public:
		//Konstruktor
		Kwadrat(int bok) : _bok(bok) {};

		//Przeciony operator porwnywania. Jest wykorzystywany
		//przez funkcj is_sorted do ustalania relacji.
		bool operator<(const Kwadrat& inny) const {
			return (this->_bok < inny._bok);
		};

		//Pobieranie danej. W przykadzie nie uywana.
		int zwroc_bok() const {return _bok;};

	private:
		//dugo boku kwadratu.
		int _bok;
};

/*	Funkcja sprawdza czy pierwszy argument ley bliej zera
 *	ni argument drugi na osi wsprzdnych.
 *	Funkcja dostarczana opcjonalnie dla is_sorted. Uywana
 *	zamiast operatora '<'. Argumenty powinny by typu
 *	jak elementy porwnywane przez is_sorted.
 *	Wynik zwracany powinien by konwertowalny do typu bool.
 */
bool czy_blizej_zera(int a, int b) {
	a = abs(a);
	b = abs(b);
	return (a < b ? true : false);
}


int main(int argc, char* argv[]) {

	//Deklaracja danych na ktrych bdziemy operowa.
	int tab1[] = {1,2,3,4,5,6,7,8};
	int tab2[] = {1,-2,-3,4,5,-6,7,-8};
	//Ilo elementw w tablicy
	const int N1 = sizeof(tab1) / sizeof(int);
	const int N2 = sizeof(tab2) / sizeof(int);

	//Wektor kwadratw o bokach z tab1
	std::vector<Kwadrat> wektor;
	for(int i = 0; i < N1; ++i)
		wektor.push_back(Kwadrat(tab1[i]));

	//Iteratory do pokazania jednego z moliwych wywoa funkcji is_sorted
	vector<Kwadrat>::iterator pierwszy = wektor.begin();
	vector<Kwadrat>::iterator ostatni = wektor.end();

	//Sposb wywoania funkcji:
	//Dla tablicy
	cout << __gnu_cxx::is_sorted(tab1, tab1+N1) << endl;
	//Dla kontenerw udostpniajcych iteratory
	cout << __gnu_cxx::is_sorted(pierwszy,ostatni) << endl;
	//Gdy chcemy zastosowa wasne kryteria porwnywania, podajemy wskanik na funkcje jako 3 parametr
	cout << __gnu_cxx::is_sorted(tab2,tab2+N2, &czy_blizej_zera) << endl;

	/* Program po uruchomieniu powinien wypisa trzy 1 pod sob oznaczajce, e is_sorted stwierdzia
	 * posortowanie danych we wszystkich trzech przypadkach
	 */



	/*
	 * Funkcji mona uy do znajdowania minimum i maximum. Przykad poniej.
	 */

	//Pomocnicza tablica do ktrej kopiujemy dane
	//Zapamitamy najwiksz do tej pory znalezion liczb i bdziemy j porwnywa z kolejnymi
	//danymi z tablicy.
	int max[2] = {0, tab1[0]};
	for(int z=1; z < N1; ++z) {
		max[0] = tab1[z];
		if(!__gnu_cxx::is_sorted(max, max+2))
			//znalelimy wiksz liczb, naley j zapamita.
			max[1] = max[0];
	}

	/*
	 * W max[1] znajduje si maksimum. Podobnie mona znajdowa minimum na wektorze liczb.
	 * Taki sposb wyszukiwania ekstremw jest przydatny gdy dostarczamy swoj funkcj porwnujc,
	 * wedug jakiego niestandardowego wzorca.
	 */

}
